From 50110f333c0f10d1237e4c6947f9dd11f476caf3 Mon Sep 17 00:00:00 2001
From: Walter Doekes <walter+github@wjd.nu>
Date: Sat, 5 Sep 2015 22:53:17 +0200
Subject: [PATCH 06/15] Add Asterisk 13 support.

Author: novaktmp, 2014-12-01 17:42:52
Source: https://forum.openwrt.org/viewtopic.php?id=54343

Slight adaptations by me.
---
 at_response.c |  13 ++++++-
 chan_dongle.c |  33 ++++++++++++++---
 chan_dongle.h |   3 +-
 channel.c     | 114 +++++++++++++++++++++++++++++++++++++++-------------------
 channel.h     |   4 +++
 manager.c     |   9 ++++-
 pdu.c         |   2 +-
 7 files changed, 133 insertions(+), 45 deletions(-)

diff --git a/at_response.c b/at_response.c
index ad3e056..e8a35b6 100644
--- a/at_response.c
+++ b/at_response.c
@@ -840,7 +840,11 @@ static int start_pbx(struct pvt* pvt, const char * number, int call_idx, call_st
 	struct cpvt* cpvt;
 
 	/* TODO: pass also Subscriber number or other DID info for exten  */
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+	struct ast_channel * channel = new_channel (pvt, AST_STATE_RING, number, call_idx, CALL_DIR_INCOMING, state, pvt->has_subscriber_number ? pvt->subscriber_number : CONF_SHARED(pvt, exten), NULL, NULL);
+#else
 	struct ast_channel * channel = new_channel (pvt, AST_STATE_RING, number, call_idx, CALL_DIR_INCOMING, state, pvt->has_subscriber_number ? pvt->subscriber_number : CONF_SHARED(pvt, exten), NULL);
+#endif
 
 	if (!channel)
 	{
@@ -853,11 +857,15 @@ static int start_pbx(struct pvt* pvt, const char * number, int call_idx, call_st
 
 		return -1;
 	}
+
 	cpvt = ast_channel_tech_pvt(channel);
 // FIXME: not execute if channel_new() failed
 	CPVT_SET_FLAGS(cpvt, CALL_FLAG_NEED_HANGUP);
 
 	// ast_pbx_start() usually failed if asterisk.conf minmemfree set too low, try drop buffer cache sync && echo 3 > /proc/sys/vm/drop_caches
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+	ast_channel_unlock(channel);
+#endif
 	if (ast_pbx_start (channel))
 	{
 		ast_channel_tech_pvt_set(channel, NULL);
@@ -922,7 +930,10 @@ static int at_response_clcc (struct pvt* pvt, char* str)
 								if(cpvt->channel)
 								{
 									/* FIXME: unprotected channel access */
-									ast_channel_rings_set(cpvt->channel, ast_channel_rings(cpvt->channel) + pvt->rings);
+									int rings = ast_channel_rings(cpvt->channel);
+									rings += pvt->rings;
+									ast_channel_rings_set(cpvt->channel, rings);
+									pvt->rings = 0;
 								}
 							}
 							if(state != cpvt->state)
diff --git a/chan_dongle.c b/chan_dongle.c
index dba5a49..84eef5c 100644
--- a/chan_dongle.c
+++ b/chan_dongle.c
@@ -45,6 +45,10 @@ ASTERISK_FILE_VERSION(__FILE__, "$Rev: " PACKAGE_REVISION " $")
 #include <asterisk/callerid.h>
 #include <asterisk/module.h>		/* AST_MODULE_LOAD_DECLINE ... */
 #include <asterisk/timing.h>		/* ast_timer_open() ast_timer_fd() */
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+#include <asterisk/stasis_channels.h>
+#include <asterisk/format_cache.h>
+#endif
 
 #include <sys/stat.h>			/* S_IRUSR | S_IRGRP | S_IROTH */
 #include <termios.h>			/* struct termios tcgetattr() tcsetattr()  */
@@ -69,12 +73,11 @@ ASTERISK_FILE_VERSION(__FILE__, "$Rev: " PACKAGE_REVISION " $")
 
 EXPORT_DEF const char * const dev_state_strs[4] = { "stop", "restart", "remove", "start" };
 EXPORT_DEF public_state_t * gpublic;
-#if ASTERISK_VERSION_NUM >= 100000 /* 10+ */
+#if ASTERISK_VERSION_NUM >= 100000 && ASTERISK_VERSION_NUM < 130000 /* 10+..13- */
 EXPORT_DEF struct ast_format chan_dongle_format;
 EXPORT_DEF struct ast_format_cap * chan_dongle_format_cap;
 #endif
 
-
 static int public_state_init(struct public_state * state);
 
 
@@ -1665,8 +1668,15 @@ static int public_state_init(struct public_state * state)
 		rv = AST_MODULE_LOAD_FAILURE;
 		if(discovery_restart(state) == 0)
 		{
-#if ASTERISK_VERSION_NUM >= 100000 /* 10+ */
+
 			/* set preferred capabilities */
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+			if (!(channel_tech.capabilities = ast_format_cap_alloc(AST_FORMAT_CAP_FLAG_DEFAULT))) {
+				return AST_MODULE_LOAD_FAILURE;
+			}
+			ast_format_cap_append(channel_tech.capabilities, ast_format_slin, 0);
+			//chan_dongle_format_cap = channel_tech.capabilities;
+#elif ASTERISK_VERSION_NUM >= 100000 /* 10-13 */
 			ast_format_set(&chan_dongle_format, AST_FORMAT_SLINEAR, 0);
 			if (!(channel_tech.capabilities = ast_format_cap_alloc())) {
 				return AST_MODULE_LOAD_FAILURE;
@@ -1687,7 +1697,10 @@ static int public_state_init(struct public_state * state)
 			}
 			else
 			{
-#if ASTERISK_VERSION_NUM >= 100000 /* 10+ */
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+			        ao2_cleanup(channel_tech.capabilities);
+			        channel_tech.capabilities = NULL;
+#elif ASTERISK_VERSION_NUM >= 100000 /* 10-13 */
 				channel_tech.capabilities = ast_format_cap_destroy(channel_tech.capabilities);
 #endif
 				ast_log (LOG_ERROR, "Unable to register channel class %s\n", channel_tech.type);
@@ -1717,7 +1730,11 @@ static void public_state_fini(struct public_state * state)
 {
 	/* First, take us out of the channel loop */
 	ast_channel_unregister (&channel_tech);
-#if ASTERISK_VERSION_NUM >= 100000 /* 10+ */
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+        ao2_cleanup(channel_tech.capabilities);
+        channel_tech.capabilities = NULL;
+
+#elif ASTERISK_VERSION_NUM >= 100000 /* 10-13 */
 	channel_tech.capabilities = ast_format_cap_destroy(channel_tech.capabilities);
 #endif
 
@@ -1766,9 +1783,15 @@ static int reload_module()
 }
 
 AST_MODULE_INFO(ASTERISK_GPL_KEY, AST_MODFLAG_DEFAULT, MODULE_DESCRIPTION,
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+		.support_level = AST_MODULE_SUPPORT_EXTENDED,
+#endif
 		.load = load_module,
 		.unload = unload_module,
 		.reload = reload_module,
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+		.load_pri = AST_MODPRI_CHANNEL_DRIVER,
+#endif
 	       );
 
 //AST_MODULE_INFO_STANDARD (ASTERISK_GPL_KEY, MODULE_DESCRIPTION);
diff --git a/chan_dongle.h b/chan_dongle.h
index b3adab7..a94cfbb 100644
--- a/chan_dongle.h
+++ b/chan_dongle.h
@@ -38,9 +38,10 @@ INLINE_DECL const char * dev_state2str_msg(dev_state_t state)
 	return enum2str(state, states, ITEMS_OF(states));
 }
 
-#if ASTERISK_VERSION_NUM >= 100000 /* 10+ */
+#if ASTERISK_VERSION_NUM >= 100000 && ASTERISK_VERSION_NUM < 130000 /* 10+..13- */
 /* Only linear is allowed */
 EXPORT_DECL struct ast_format chan_dongle_format;
+//EXPORT_DEF struct ast_format chan_dongle_format;
 EXPORT_DECL struct ast_format_cap * chan_dongle_format_cap;
 #endif
 
diff --git a/channel.c b/channel.c
index 73e4033..7c978e6 100644
--- a/channel.c
+++ b/channel.c
@@ -26,6 +26,10 @@
 #include <asterisk/timing.h>			/* ast_timer_fd() ast_timer_set_rate() ast_timer_ack() */
 
 #include "ast_compat.h"
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+#include <asterisk/stasis_channels.h>
+#include <asterisk/format_cache.h>
+#endif
 
 #include "channel.h"
 #include "chan_dongle.h"
@@ -96,23 +100,27 @@ EXPORT_DEF int channels_loop(struct pvt * pvt, const struct ast_channel * reques
 	/* FIXME: requestor may be just proxy/masquerade for real channel */
 	//	use ast_bridged_channel(chan) ?
 	//	use requestor->tech->get_base_channel() ?
-	struct cpvt *cpvt = ast_channel_tech_pvt(requestor);
-	if(requestor && ast_channel_tech(requestor) == &channel_tech && cpvt && cpvt->pvt == pvt)
-		return 1;
-	return 0;
+	return (requestor
+		&& ast_channel_tech(requestor) == &channel_tech
+		&& ast_channel_tech_pvt(requestor)
+		&& ((struct cpvt*) ast_channel_tech_pvt(requestor))->pvt == pvt)
+		? 1
+		: 0;
 }
 
-// TODO: simplify by move common code to functions
-/* TODO: add check when request 'holdother' what requestor is not on same device for 1.6 */
-#if ASTERISK_VERSION_NUM >= 110000 /* 11+ */
-static struct ast_channel * channel_request (attribute_unused const char *type, struct ast_format_cap *cap, const struct ast_channel *requestor, const char *data, int *cause)
-#elif ASTERISK_VERSION_NUM >= 100000 /* 10+ */
-static struct ast_channel * channel_request (attribute_unused const char * type, struct ast_format_cap * cap, const struct ast_channel *requestor, void * data, int * cause)
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+static struct ast_channel * channel_request (attribute_unused const char * type, struct ast_format_cap * cap, const struct ast_assigned_ids * assignedids, const struct ast_channel * requestor, const char * data, int * cause)
+#elif ASTERISK_VERSION_NUM >= 110000 /* 11+ */
+static struct ast_channel * channel_request (attribute_unused const char * type, struct ast_format_cap * cap, const struct ast_channel * requestor, const char * data, int * cause)
+#elif ASTERISK_VERSION_NUM >= 100000 /* 10-13 */
+static struct ast_channel * channel_request (attribute_unused const char * type, struct ast_format_cap * cap, const struct ast_channel * requestor, void * data, int * cause)
 #elif ASTERISK_VERSION_NUM >= 10800 /* 1.8+ */
+//   TODO: simplify by move common code to functions
 static struct ast_channel * channel_request (attribute_unused const char * type, format_t format, const struct ast_channel * requestor, void * data, int * cause)
-#else /* #if ASTERISK_VERSION_NUM < 10800 */
+#else /* 1.8- */
+/* TODO: add check when request 'holdother' what requestor is not on same device for 1.6 */
 static struct ast_channel * channel_request (attribute_unused const char * type, int format, void * data, int * cause)
-#endif /* #if ASTERISK_VERSION_NUM < 10800 */
+#endif
 {
 #if ASTERISK_VERSION_NUM >= 10800 && ASTERISK_VERSION_NUM < 100000 /* 1.8+ .. 10- */
 	format_t oldformat;
@@ -134,15 +142,20 @@ static struct ast_channel * channel_request (attribute_unused const char * type,
 		return NULL;
 	}
 
-#if ASTERISK_VERSION_NUM >= 100000 /* 10+ */
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+	if (ast_format_cap_iscompatible_format(cap, ast_format_slin) != AST_FORMAT_CMP_EQUAL)
+#elif ASTERISK_VERSION_NUM >= 100000 /* 10-13 */
 	if (!ast_format_cap_iscompatible(cap, &chan_dongle_format))
 #else
-        oldformat = format;
-        format &= AST_FORMAT_SLINEAR;
-        if (!format)
+	oldformat = format;
+	format &= AST_FORMAT_SLINEAR;
+	if (!format)
 #endif
-        {
-#if ASTERISK_VERSION_NUM >= 100000 /* 10+ */
+	{
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+		struct ast_str *codec_buf = ast_str_alloca(64);
+		ast_log (LOG_WARNING, "Asked to get a channel of unsupported format '%s'\n", ast_format_cap_get_names(cap, &codec_buf));
+#elif ASTERISK_VERSION_NUM >= 100000 /* 10-13 */
 		char buf[255];
 		ast_log (LOG_WARNING, "Asked to get a channel of unsupported format '%s'\n", ast_getformatname_multiple (buf, 255, cap));
 #elif ASTERISK_VERSION_NUM >= 10800 /* 1.8+ */
@@ -167,7 +180,11 @@ static struct ast_channel * channel_request (attribute_unused const char * type,
 #endif
 	if(pvt)
 	{
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+		channel = new_channel (pvt, AST_STATE_DOWN, NULL, pvt_get_pseudo_call_idx(pvt), CALL_DIR_OUTGOING, CALL_STATE_INIT, NULL, assignedids, requestor);
+#else
 		channel = new_channel (pvt, AST_STATE_DOWN, NULL, pvt_get_pseudo_call_idx(pvt), CALL_DIR_OUTGOING, CALL_STATE_INIT, NULL, requestor);
+#endif
 		ast_mutex_unlock (&pvt->lock);
 		if(!channel)
 		{
@@ -592,13 +609,13 @@ static void write_conference(struct pvt * pvt, const char * buffer, size_t lengt
 
 
 #if ASTERISK_VERSION_NUM >= 100000 /* 10+ */
-#define subclass_integer       subclass.integer
+#define subclass_integer	subclass.integer
 #elif ASTERISK_VERSION_NUM >= 10800 /* 1.8+ */
-#define subclass_codec         subclass.codec
-#define subclass_integer       subclass.integer
+#define subclass_codec		subclass.codec
+#define subclass_integer	subclass.integer
 #else /* 1.8- */
-#define subclass_codec         subclass
-#define subclass_integer       subclass
+#define subclass_codec		subclass
+#define subclass_integer	subclass
 #endif
 
 #/* */
@@ -640,7 +657,9 @@ static struct ast_frame* channel_read (struct ast_channel* channel)
 		memset (&cpvt->a_read_frame, 0, sizeof (cpvt->a_read_frame));
 
 		cpvt->a_read_frame.frametype = AST_FRAME_VOICE;
-#if ASTERISK_VERSION_NUM >= 100000 /* 10+ */
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+		cpvt->a_read_frame.subclass.format = ao2_bump(ast_format_slin);
+#elif ASTERISK_VERSION_NUM >= 100000 /* 10-13 */
 		ast_format_copy(&cpvt->a_read_frame.subclass.format, &chan_dongle_format);
 #else
 		cpvt->a_read_frame.subclass_codec = AST_FORMAT_SLINEAR;
@@ -758,7 +777,9 @@ static int channel_write (struct ast_channel* channel, struct ast_frame* f)
 	size_t count;
 	int gains[2];
 
-#if ASTERISK_VERSION_NUM >= 100000 /* 10+ */
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+	if (f->frametype != AST_FRAME_VOICE || ast_format_cmp(f->subclass.format, ast_format_slin) != AST_FORMAT_CMP_EQUAL)
+#elif ASTERISK_VERSION_NUM >= 100000 /* 10-13 */
 	if (f->frametype != AST_FRAME_VOICE || f->subclass.format.id != AST_FORMAT_SLINEAR)
 #else /* 10- */
 	if (f->frametype != AST_FRAME_VOICE || f->subclass_codec != AST_FORMAT_SLINEAR)
@@ -793,13 +814,16 @@ static int channel_write (struct ast_channel* channel, struct ast_frame* f)
 
 	if(CPVT_TEST_FLAG(cpvt, CALL_FLAG_MULTIPARTY) && !CPVT_TEST_FLAG(cpvt, CALL_FLAG_BRIDGE_CHECK))
 	{
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+		RAII_VAR(struct ast_channel *, bridged, ast_channel_bridge_peer(channel), ast_channel_cleanup);
+#else
 		struct ast_channel* bridged = ast_bridged_channel(channel);
+#endif
 		struct cpvt *tmp_cpvt;
 
 		CPVT_SET_FLAGS(cpvt, CALL_FLAG_BRIDGE_CHECK);
 
-		tmp_cpvt = ast_channel_tech_pvt(bridged);
-		if(bridged && ast_channel_tech(bridged) == &channel_tech && tmp_cpvt && tmp_cpvt->pvt == pvt)
+		if (bridged && ast_channel_tech(bridged) == &channel_tech && (tmp_cpvt = ast_channel_tech_pvt(bridged)) && tmp_cpvt->pvt == pvt)
 		{
 			CPVT_SET_FLAGS(cpvt, CALL_FLAG_BRIDGE_LOOP);
 			CPVT_SET_FLAGS((struct cpvt*)ast_channel_tech_pvt(bridged), CALL_FLAG_BRIDGE_LOOP);
@@ -1004,6 +1028,7 @@ static int channel_indicate (struct ast_channel* channel, int condition, const v
 		case AST_CONTROL_PROCEEDING:
 		case AST_CONTROL_VIDUPDATE:
 		case AST_CONTROL_SRCUPDATE:
+		case AST_CONTROL_PVT_CAUSE_CODE://33
 			break;
 
 		case AST_CONTROL_HOLD:
@@ -1154,7 +1179,12 @@ static void set_channel_vars(struct pvt* pvt, struct ast_channel* channel)
 		{ "DONGLENUMBER", pvt->subscriber_number },
 	};
 
+#if ASTERISK_VERSION_NUM >= 110000 /* 11+  */
 	ast_channel_language_set(channel, CONF_SHARED(pvt, language));
+#else
+	//TODO uncomment and fix
+	//ast_string_field_set (channel, language, CONF_SHARED(pvt, language);
+#endif
 
 	for(idx = 0; idx < ITEMS_OF(dev_vars); ++idx)
 		pbx_builtin_setvar_helper (channel, dev_vars[idx].name, dev_vars[idx].value);
@@ -1162,16 +1192,24 @@ static void set_channel_vars(struct pvt* pvt, struct ast_channel* channel)
 }
 
 #/* NOTE: called from device and current levels with locked pvt */
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+EXPORT_DEF struct ast_channel* new_channel (struct pvt* pvt, int ast_state, const char* cid_num, int call_idx, unsigned dir, call_state_t state, const char * dnid, const struct ast_assigned_ids *assignedids, attribute_unused const struct ast_channel * requestor)
+#else
 EXPORT_DEF struct ast_channel* new_channel (struct pvt* pvt, int ast_state, const char* cid_num, int call_idx, unsigned dir, call_state_t state, const char * dnid, attribute_unused const struct ast_channel * requestor)
+#endif
 {
+//        struct ast_channel * channel = new_channel (pvt, AST_STATE_RING, number, call_idx, CALL_DIR_INCOMING, state, pvt->has_subscriber_number ? pvt->subscriber_number : CONF_SHARED(pvt, exten), $
+
 	struct ast_channel* channel;
 	struct cpvt * cpvt;
 
 	cpvt = cpvt_alloc(pvt, call_idx, dir, state);
 	if (cpvt)
 	{
-#if ASTERISK_VERSION_NUM >= 10800
-		channel = ast_channel_alloc (1, ast_state, cid_num, PVT_ID(pvt), NULL, dnid, CONF_SHARED(pvt, context), requestor ? ast_channel_linkedid(requestor) : NULL, 0, "%s/%s-%02u%08lx", channel_tech.type, PVT_ID(pvt), call_idx, pvt->channel_instanse);
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+                channel = ast_channel_alloc (1, ast_state, cid_num, PVT_ID(pvt), NULL, dnid, CONF_SHARED(pvt, context), assignedids, requestor, 0, "%s/%s-%02u%08lx", channel_tech.type, PVT_ID(pvt), call_idx, pvt->channel_instanse);
+#elif ASTERISK_VERSION_NUM >= 10800 /* 1.8+ */
+		channel = ast_channel_alloc (1, ast_state, cid_num, PVT_ID(pvt), NULL, dnid, CONF_SHARED(pvt, context), requestor ? ast_channel_linkedid(requestor): NULL, 0, "%s/%s-%02u%08lx", channel_tech.type, PVT_ID(pvt), call_idx, pvt->channel_instanse);
 #else
 		channel = ast_channel_alloc (1, ast_state, cid_num, PVT_ID(pvt), NULL, dnid, CONF_SHARED(pvt, context), 0, "%s/%s-%02u%08lx", channel_tech.type, PVT_ID(pvt), call_idx, pvt->channel_instanse);
 #endif
@@ -1183,8 +1221,11 @@ EXPORT_DEF struct ast_channel* new_channel (struct pvt* pvt, int ast_state, cons
 			ast_channel_tech_pvt_set(channel, cpvt);
 			ast_channel_tech_set(channel, &channel_tech);
 
-
-#if ASTERISK_VERSION_NUM >= 110000 /* 11+ */
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+			ast_format_cap_append(ast_channel_nativeformats(channel), ast_format_slin, 0);
+			ast_channel_set_writeformat(channel, ast_format_slin);
+			ast_channel_set_readformat(channel, ast_format_slin);
+#elif ASTERISK_VERSION_NUM >= 110000 /* 11+ */
 			ast_format_set(ast_channel_readformat(channel), AST_FORMAT_SLINEAR, 0);
 			ast_format_set(ast_channel_writeformat(channel), AST_FORMAT_SLINEAR, 0);
 			ast_format_cap_set(ast_channel_nativeformats(channel), ast_channel_writeformat(channel));
@@ -1285,11 +1326,13 @@ EXPORT_DEF void start_local_channel (struct pvt* pvt, const char* exten, const c
 
 	snprintf (channel_name, sizeof (channel_name), "%s@%s", exten, CONF_SHARED(pvt, context));
 
-#if ASTERISK_VERSION_NUM >= 100000 /* 10+ */
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+	channel = ast_request ("Local", channel_tech.capabilities, NULL, NULL, channel_name, &cause);
+#elif ASTERISK_VERSION_NUM >= 100000 /* 10-13 */
 	channel = ast_request ("Local", chan_dongle_format_cap, NULL, channel_name, &cause);
 #elif ASTERISK_VERSION_NUM >= 10800 /* 1.8+ */
 	channel = ast_request ("Local", AST_FORMAT_AUDIO_MASK, NULL, channel_name, &cause);
-#else
+#else /* 1.8- */
 	channel = ast_request ("Local", AST_FORMAT_AUDIO_MASK, channel_name, &cause);
 #endif
 	if (channel)
@@ -1374,7 +1417,7 @@ static int channel_func_read(struct ast_channel* channel, attribute_unused const
 static int channel_func_write(struct ast_channel* channel, const char* function, char* data, const char* value)
 {
 	struct cpvt* cpvt = ast_channel_tech_pvt(channel);
-	struct pvt* pvt;
+	struct pvt* pvt = cpvt->pvt;
 	call_state_t newstate, oldstate;
 	int ret = 0;
 
@@ -1383,7 +1426,6 @@ static int channel_func_write(struct ast_channel* channel, const char* function,
 		ast_log (LOG_WARNING, "call on unreferenced %s\n", ast_channel_name(channel));
 		return -1;
 	}
-	pvt = cpvt->pvt;
 
 	if (!strcasecmp(data, "callstate"))
 	{
@@ -1455,7 +1497,7 @@ EXPORT_DEF struct ast_channel_tech channel_tech =
 	.type			= "Dongle",
 	.description		= MODULE_DESCRIPTION,
 #if ASTERISK_VERSION_NUM < 100000 /* 10- */
-	.capabilities           = AST_FORMAT_SLINEAR,
+	.capabilities		= AST_FORMAT_SLINEAR,
 #endif
 	.requester		= channel_request,
 	.call			= channel_call,
diff --git a/channel.h b/channel.h
index e62bc9d..702e3f2 100644
--- a/channel.h
+++ b/channel.h
@@ -21,7 +21,11 @@ struct cpvt;
 
 EXPORT_DECL struct ast_channel_tech channel_tech;
 
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+EXPORT_DECL struct ast_channel* new_channel (struct pvt * pvt, int ast_state, const char * cid_num, int call_idx, unsigned dir, unsigned state, const char * exten, const struct ast_assigned_ids *assignedids, const struct ast_channel * requestor);
+#else
 EXPORT_DECL struct ast_channel* new_channel (struct pvt * pvt, int ast_state, const char * cid_num, int call_idx, unsigned dir, unsigned state, const char * exten, const struct ast_channel * requestor);
+#endif
 EXPORT_DECL int queue_control_channel (struct cpvt * cpvt, enum ast_control_frame_type control);
 EXPORT_DECL int queue_hangup (struct ast_channel * channel, int hangupcause);
 EXPORT_DECL void start_local_channel (struct pvt * pvt, const char * exten, const char * number, channel_var_t * vars);
diff --git a/manager.c b/manager.c
index 4f9e962..0f9a0ca 100644
--- a/manager.c
+++ b/manager.c
@@ -731,9 +731,16 @@ static const struct dongle_manager
 EXPORT_DEF void manager_register()
 {
 	unsigned i;
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+	struct ast_module* module = self_module();
+#endif
+
 	for(i = 0; i < ITEMS_OF(dcm); i++)
 	{
-#if ASTERISK_VERSION_NUM >= 110000
+#if ASTERISK_VERSION_NUM >= 130000 /* 13+ */
+		ast_manager_register2 (dcm[i].name, dcm[i].authority, dcm[i].func,
+			module, dcm[i].brief, dcm[i].desc);
+#elif ASTERISK_VERSION_NUM >= 110000 /* 11+ */
 		ast_manager_register2 (dcm[i].name, dcm[i].authority, dcm[i].func, NULL, dcm[i].brief, dcm[i].desc);
 #else
 		ast_manager_register2 (dcm[i].name, dcm[i].authority, dcm[i].func, dcm[i].brief, dcm[i].desc);
diff --git a/pdu.c b/pdu.c
index 5f87db3..e0bdab7 100644
--- a/pdu.c
+++ b/pdu.c
@@ -463,7 +463,7 @@ static int pdu_parse_number(char ** pdu, size_t * pdu_length, unsigned digits, i
 				*number++ = digit;
 
 				digit = pdu_code2digit(pdu[0][0]);
-				if(digit < 0 || (digit == 0 && (syms != 2 || (digits & 0x1) == 0)))
+				if((signed char)digit < 0 || (digit == 0 && (syms != 2 || (digits & 0x1) == 0)))
 					return -1;
 
 				*number++ = digit;

